(document:surround "/std/frame")

(define (ui-write)
  (catch/message
    (lambda()
      (let ((passwd_1 (form-value "passwd_1"))
	    (passwd_2 (form-value "passwd_2"))
	    (passwd_auto (form-value "passwd_auto"))
	    (auto (form-value "auto"))
	    (gecos (form-value "gecos"))
	    (name (form-value "new_name")))
	(cond
	  ((string-null? name)
	   (or (pair? (woo-list "/users"))
	       (woo-throw (_ "You should define a system user"))))
	  ((or (and (not auto) (string-null? passwd_1))
	       (and auto (string-null? passwd_auto)))
	   (woo-throw (_ "You should define a password")))
	  (else
	    (woo-new "/users"
		     'new_name name
		     'gecos gecos
		     'allow_su #t
		     'auto auto
		     'passwd_auto passwd_auto
		     'passwd_1 passwd_1
		     'passwd_2 passwd_2)))))))

(define (ui-auto . auto)
  (let ((auto (if (pair? auto) (car auto) (form-value "auto"))))
    (form-update-visibility
      '("passwd_auto" "generate_button")
      auto)
    (form-update-visibility
      '("passwd_1" "passwd_2")
      (not auto))))

(define (ui-generate)
  (form-update-value-list
    '("passwd_auto")
    (car (woo "generate" "/users"))))

(define (ui-init)
  (ui-generate)
  (form-bind "auto" "change" ui-auto)
  (form-bind "generate_button" "click" ui-generate))

;;;;;;;;;;;;;;;;;;;;;;;;;

(frame:on-next (lambda() (or (ui-write) 'cancel)))

;;; UI

(gridbox
  columns "20;0;60;20"
  ;;
  (spacer)
  (label text (_ "New user account") colspan 3)
  ;;
  (label colspan 4)
  ;;
  (spacer)
  (label text (_ "Name:") align "right" nameref "new_name")
  (edit focus #t name "new_name")
  (spacer)
  ;;
  (spacer)
  (label text (_ "Comment:") align "right" nameref "gecos")
  (edit name "gecos")
  (spacer)

  ;;
  (label colspan 4)

  ;;
  (spacer)
  (label text (_ "Password:") align "top;right")
  (gridbox
    columns "100;0"
    (checkbox text (_ "Generate automatically") name "auto")
    (spacer)
    (edit name "passwd_1" echo "stars")
    (label nameref "passwd_1" text (small (_ "(enter passphrase)")))
    (edit name "passwd_2" echo "stars")
    (label nameref "passwd_2" text (small (_ "(repeat passphrase)")))
    (edit name "passwd_auto" visibility #f alterability #f)
    (button text (_ "Generate") name "generate_button" visibility #f)
    (label colspan 2 nameref "passwd_auto" visibility #f))
  (spacer))

;;; Logic

(document:root (when loaded (ui-init)))
